import random
from aiortc.contrib.media import MediaBlackhole, MediaPlayer, MediaRecorder, MediaRelay
from aiortc import VideoStreamTrack, AudioStreamTrack

class MyMediaPlayer(MediaPlayer):
	pass

class MyAudioStreamTrack(AudioStreamTrack):
	def __init__(self, source=None):
		super().__init__()
		self.source = source

	def set_source(self, source):
		self.source = source

	async def recv(self):
		print('MyAudioTrack::recv(): called')
		
		if self.source is None:
			return None
		f = await self.source.audio.recv()
		while f is None:
			self.set_source(MediaPlayer(self.source._file_path)
			f = await self.source.audio.recv()
		return f

class MyVideoStreamTrack(VideoStreamTrack):
	def __init__(self, source=None):
		super().__init__()
		self.source = source

	def set_source(self, source):
		self.source = source

	async def recv(self):
		print('MyVideoTrack::recv(): called')
		if self.source is None:
			return None
		f = await self.source.video.recv()
		while f is None:
			self.set_source(MediaPlayer(self.source._file_path)
			f = await self.source.video.recv()
		return f
